import numpy as np

atom=np.dtype([('sym','S3'),('PA','int'),('x','float64'),('y','float64'),('z','float64')])
p=np.array([('o',8,0.0,0.0,0.0),('h',1,0.0,0.0,1.89),('h',1,1.861,0.0,-0.328)],dtype=atom)
print p

a=np.loadtxt('mol.xyz',dtype=atom)
print a
#Array dei pesi atomici
pa=a['PA']
mw=pa.sum()
print 'Molecular weight', mw
#Coordinate
coord=np.array([a['x'],a['y'],a['z']])
print coord.shape
print coord.mean(axis=1)

#Contributi parziali al calcolo del peso atomico
print 'C: ', a[a['sym']=='C']['PA'].sum()
print 'O: ', a[a['sym']=='O']['PA'].sum()
print 'N: ', a[a['sym']=='N']['PA'].sum()
print 'H: ', a[a['sym']=='H']['PA'].sum()


#Calcolo del centro di massa molecolare
xcm = 1./a['PA'].sum() * (a['PA']*a['x']).sum()
ycm = 1./a['PA'].sum() * (a['PA']*a['y']).sum()
zcm = 1./a['PA'].sum() * (a['PA']*a['z']).sum()
print 'xcm ',xcm, 'ycm ',ycm, 'zcm ',zcm

#Calcolo del tensore del momento di inerzia
Ixx = (a['PA']*(a['y']**2 + a['z']**2)).sum()
Iyy = (a['PA']*(a['x']**2 + a['z']**2)).sum()
Izz = (a['PA']*(a['x']**2 + a['y']**2)).sum()
Ixy = - (a['PA']* a['x'] * a['y']).sum()
Ixz = - (a['PA']* a['x'] * a['z']).sum()
Iyz = - (a['PA']* a['y'] * a['z']).sum()

mTI = np.matrix([[Ixx,Ixy,Ixz],[Ixy,Iyy,Iyz],[Ixz,Iyz,Izz]])
